
#ifndef CC2500_REGISTERS_H
#define	CC2500_REGISTERS_H

#ifdef	__cplusplus
extern "C" {
#endif



typedef enum {
CC2500_IOCFG2          = 0x0000,   // 0  desired value:29  IOCFG2 GDO2 output pin configuration                  
CC2500_IOCFG1          = 0x0001,   // 1  desired value:2E  IOCFG1 GDO1 output pin configuration                 
CC2500_IOCFG0          = 0x0002,   // 2  desired value:06  IOCFG0 GDO0 output pin configuration                 
CC2500_FIFOTHR         = 0x0003,   // 3  desired value:07  FIFOTHR RX FIFO and TX FIFO thresholds               
CC2500_SYNC1           = 0x0004,   // 4  desired value:D3  SYNC1 Sync word, high byte                           
CC2500_SYNC0           = 0x0005,   // 5  desired value:91  SYNC0 Sync word, low byte                            
CC2500_PKTLEN          = 0x0006,   // 6  desired value:FF  PKTLEN Packet length                                 
CC2500_PKTCTRL1        = 0x0007,   // 7  desired value:04  PKTCTRL1 Packet automation control                   
CC2500_PKTCTRL0        = 0x0008,   // 8  desired value:05  PKTCTRL0 Packet automation control                  
CC2500_ADDR            = 0x0009,   // 9  desired value:00  ADDR Device address                                  
CC2500_CHANNR          = 0x000A,   // 10 desired value:00  CHANNR Channel number                                 
CC2500_FSCTRL1         = 0x000B,   // 11 desired value:10  FSCTRL1 Frequency synthesizer control                   
CC2500_FSCTRL0         = 0x000C,   // 12 desired value:00  FSCTRL0 Frequency synthesizer control                
CC2500_FREQ2           = 0x000D,   // 13 desired value:5C  FREQ2 Frequency control word, high byte               
CC2500_FREQ1           = 0x000E,   // 14 desired value:60  FREQ1 Frequency control word, middle byte            
CC2500_FREQ0           = 0x000F,   // 15 desired value:7E  FREQ0 Frequency control word, low byte               
CC2500_MDMCFG4         = 0x0010,   // 16 desired value:0E  MDMCFG4 Modem configuration                          
CC2500_MDMCFG3         = 0x0011,   // 17 desired value:3B  MDMCFG3 Modem configuration                           
CC2500_MDMCFG2         = 0x0012,   // 18 desired value:73  MDMCFG2 Modem configuration                           
CC2500_MDMCFG1         = 0x0013,   // 19 desired value:43  MDMCFG1 Modem configuration                           
CC2500_MDMCFG0         = 0x0014,   // 20 desired value:84  MDMCFG0 Modem configuration                           
CC2500_DEVIATN         = 0x0015,   // 21 desired value:00  DEVIATN Modem deviation setting                       
CC2500_MCSM2           = 0x0016,   // 22 desired value:07  MCSM2 Main Radio Control State Machine configuration  
CC2500_MCSM1           = 0x0017,   // 23 desired value:30  MCSM1 Main Radio Control State Machine configuration  
CC2500_MCSM0           = 0x0018,   // 24 desired value:18  MCSM0 Main Radio Control State Machine configuration  
CC2500_FOCCFG          = 0x0019,   // 25 desired value:1D  FOCCFG Frequency Offset Compensation configuration    
CC2500_BSCFG           = 0x001A,   // 26 desired value:1C  BSCFG Bit Synchronization configuration               
CC2500_AGCCTRL2        = 0x001B,   // 27 desired value:C7  AGCTRL2 AGC control                                   
CC2500_AGCCTRL1        = 0x001C,   // 28 desired value:40  AGCTRL1 AGC control                                   
CC2500_AGCCTRL0        = 0x001D,   // 29 desired value:B0  AGCTRL0 AGC control                                   
CC2500_WOREVT1         = 0x001E,   // 30 desired value:87  WOREVT1 High byte Event 0 timeout                     
CC2500_WOREVT0         = 0x001F,   // 31 desired value:6B  WOREVT0 Low byte Event 0 timeout                      
CC2500_WORCTRL         = 0x0020,   // 32 desired value:F8  WORCTRL Wake On Radio control                         
CC2500_FREND1          = 0x0021,   // 33 desired value:B6  FREND1 Front end RX configuration                     
CC2500_FREND0          = 0x0022,   // 34 desired value:10  FREND0 Front end TX configuration                     
CC2500_FSCAL3          = 0x0023,   // 35 desired value:EA  FSCAL3 Frequency synthesizer calibration              
CC2500_FSCAL2          = 0x0024,   // 36 desired value:0A  FSCAL2 Frequency synthesizer calibration              
CC2500_FSCAL1          = 0x0025,   // 37 desired value:00  FSCAL1 Frequency synthesizer calibration              
CC2500_FSCAL0          = 0x0026,   // 38 desired value:19  FSCAL0 Frequency synthesizer calibration              
CC2500_RCCTRL1         = 0x0027,   // 39 desired value:41  RCCTRL1 RC oscillator configuration                   
CC2500_RCCTRL0         = 0x0028,   // 40 desired value:00  RCCTRL0 RC oscillator configuration                   
CC2500_FSTEST          = 0x0029,   // 41 desired value:59  FSTEST Frequency synthesizer calibration control      
CC2500_PTEST           = 0x002A,   // 42 desired value:7F  PTEST Production test                                 
CC2500_AGCTEST         = 0x002B,   // 43 desired value:3F  AGCTEST AGC test                                      
CC2500_TEST2           = 0x002C,   // 44 desired value:88  TEST2 Various test settings                           
CC2500_TEST1           = 0x002D,   // 45 desired value:31  TEST1 Various test settings                           
CC2500_TEST0           = 0x002E,   // 46 desired value:0B  TEST0 Various test settings                           
CC2500_PARTNUM         = 0x0030,   // 47 desired value:80  PARTNUM CC2500 part number                              
CC2500_VERSION         = 0x0031,   // 48 desired value:03  VERSION Current version number                         
CC2500_FREQEST         = 0x0032,   // 49 desired value:00  FREQEST Frequency offset estimate                       
CC2500_LQI             = 0x0033,   // 50 desired value:00  LQI Demodulator estimate for Link Quality               
CC2500_RSSI            = 0x0034,   // 51 desired value:00  RSSI Received signal strength indication                
CC2500_MARCSTATE       = 0x0035,   // 52 desired value:00  MARCSTATE Control state machine state                   
CC2500_WORTIME1        = 0x0036,   // 52 desired value:00  WORTIME1 High byte of WOR timer                         
CC2500_WORTIME0        = 0x0037,   // 53 desired value:00  WORTIME0 Low byte of WOR timer                          
CC2500_PKTSTATUS       = 0x0038,   // 54 desired value:00  PKTSTATUS Current GDOx status and packet status         
CC2500_VCO_VC_DAC      = 0x0039,   // 55 desired value:00  VCO_VC_DAC Current setting from PLL calibration module  
CC2500_TXBYTES         = 0x003A,   // 56 desired value:00  TXBYTES Underflow and number of bytes in the TX FIFO    
CC2500_RXBYTES         = 0x003B,   // 57 desired value:00  RXBYTES Overflow and number of bytes in the RX FIFO     
CC2500_RCCTRL1_STATUS  = 0x003C,   // 58 desired value:00  RCCTRL1_STATUS Last RC oscillator calibration result   
CC2500_RCCTRL0_STATUS  = 0x003D,   // 59 desired value:00  RCCTRL0_STATUS Last RC oscillator calibration result
CC2500_PATABLE          = 0x003E,   // 60 desired value:00  PATABLE
CC2500_FIFO            = 0x003F,   // 61 desired value:00  FIFO access
        
}CC2500Registers_Enum;                   
                                         
                                         
typedef enum 
{
    CC2500_STROBE_SRES      = 0x30,
    CC2500_STROBE_SFSTXON   = 0x31,
    CC2500_STROBE_SXOFF     = 0x32,
    CC2500_STROBE_SCAL      = 0x33,
    CC2500_STROBE_SRX       = 0x34,
    CC2500_STROBE_STX       = 0x35,
    CC2500_STROBE_SIDLE     = 0x36,

    CC2500_STROBE_SWOR      = 0x38,
    CC2500_STROBE_SPWD      = 0x39,
    CC2500_STROBE_SFRX      = 0x3A,
    CC2500_STROBE_SFTX      = 0x3B,
    CC2500_STROBE_SWORRST   = 0x3C,
    CC2500_STROBE_SNOP      = 0x3D,
}CC2500StrobeCommands_Enum;


#ifdef	__cplusplus
}
#endif

#endif	/* CC2500_REGISTERS_H */



//#define MCSM1_CCA_MODE_ALWAYS                   0x00
//#define MCSM1_CCA_MODE_RSSI_BELOW_TH            (1<<4)
//#define MCSM1_CCA_MODE_UNLESS_RECEIVING         (1<<5)
//#define MCSM1_CCA_MODE_RSSI_BELOW_TH_UNLESS_RECEIVING ((1<<4) | (1<<5))
//
//#define MCSM1_RXOFF_MODE_IDLE                   0x00
//#define MCSM1_RXOFF_MODE_FSTXON                 (1<<2)          
//#define MCSM1_RXOFF_MODE_TX                     (1<<3)
//#define MCSM1_RXOFF_MODE_RX                     ((1<<2) | (1<<3))
//
//#define MCSM1_TXOFF_MODE_IDLE                   0x00
//#define MCSM1_TXOFF_MODE_FSTXON                 (1<<0)
//#define MCSM1_TXOFF_MODE_TX                     (1<<1)
//#define MCSM1_TXOFF_MODE_RX                     ((1<<0) | (1<<1))
//
////MCSM0
//#define MCSM0_FS_AUTOCAL_NEVER                  0x00
//#define MCSM0_FS_AUTOCAL_IDLE_TO_RXTX           (1<<4)
//#define MCSM0_FS_AUTOCAL_RXTX_TO_IDLE           (1<<5)
//#define MCSM0_FS_AUTOCAL_4TH_RXTX_TO_IDLE       ((1<<4) | (1<<5))
//
//#define MCSM0_PO_TIMEOUT_COUNT_1                0x00
//#define MCSM0_PO_TIMEOUT_COUNT_16               (1<<2)
//#define MCSM0_PO_TIMEOUT_COUNT_64               (1<<3)
//#define MCSM0_PO_TIMEOUT_COUNT_256              ((1<<2) | (1<<3))
//
//










































